;***************************************************************************
;   casovac
;***************************************************************************
ind     equ     00h    
rtcc    equ     01h     
pc      equ     02h     
stat    equ     03h    
fsr     equ     04h     
pa      equ     05h     
pb      equ     06h     

sec     equ     0ch     
secu    equ     0dh
citac   equ     0eh     
konec   equ     0fh     
stav1   equ     10h     
cit_m   equ     11h     
digit   equ     12h     
new     equ     13h     
old     equ     14h      
cit_p   equ     15h     
zac     equ     16h     
k       equ     17h
w       equ     00h     
f       equ     01h     
carry   equ     00h     
dcarry  equ     01h     
nula    equ     02h     
push    equ     00h     
stop    equ     01h     
hm      equ     02h
dp      equ     07h
zv      equ     03h

        org     1ffh         
        goto    init
        org     000h

; Rutina kduje BCD slice na kd pro sedmisegmentov displej. 

tab1    addwf   pc, f           ; vbr slice
        retlw   b'11000000'     ; 0 - zobraz 0
        retlw   b'11111001'     ; atd.
        retlw   b'10100100'    
        retlw   b'10110000'    
        retlw   b'10011001'   
        retlw   b'10010010'     
        retlw   b'10000010'     
        retlw   b'11111000'    
        retlw   b'10000000'    
        retlw   b'10010000'   

; Rutina kduje podle cit_m jednu anodu, kter bude aktivn. 

tab2    addwf   pc, f           ; vbr anody
        retlw   b'11111101'
        retlw   b'11111110'

tab3    addwf   pc,f
        retlw   b'11110101'
        retlw   b'11110110'      

; Rutina rozsvt na 5ms jednu slici ze dvou monch.
 
zobraz  btfsc   stav1,stop
        movlw   b'11110111'
        movlw   0ffh
        movwf   pa              ; odpojen anod displeje
        movlw   sec
        movwf   fsr             ; adresa registru sec do fsr
        btfsc   stav1,hm
        incf    fsr,f
        bcf     stat, carry     
        rrf     cit_m, w        
        iorlw   00h             ; nastavuje bit nula stavovho slova
        btfss   stat,nula
        incf    fsr,f
        movf    ind, w          ; vybran registr do w
        movwf   digit           ; a w do digit
        btfss   stat, carry     
        swapf   digit, f       
        movlw   b'00001111'
        andwf   digit, w        ; zamaskovn
        call    tab1            ; pekodovn
        movwf   pb          
        movf    cit_m, w        ; cit_m do w
        btfsc   stav1,stop
        call    tab2            ; podle cit_m dekdujeme jednu anodu
        call    tab3
        movwf   pa              ; aktivace anody
zobr_a  incf    cit_m, f        ; inkrementujeme cit_m
        movlw   b'00000001'
        andwf   cit_m, f        ; zamaskovn, cit_m  t jen do 2
        return             


a       movf    sec,w  
        movwf   secu          
        bsf     stav1,stop
        bsf     pb,dp
        return

; Rutina te tlatka.

tlac    movf    cit_m, w
        btfss   stat, nula      
        retlw   00h           
        movlw   b'11111111'    
        movwf   pa              ; odpojen anod displeje
        clrf    pb              
        movlw   b'11111110'    
        tris    pb              ; RB0 vstup, ostatn vstupy
        movlw   .66
        movwf   cit_p           
tl_a    decfsz  cit_p, f        ; prodleva na ustlen stavu
        goto    tl_a        
        movf    pb, w           ; ten portu B 
        xorlw   b'11111111'     ; negace stavu tlatek
        andlw   b'00011110'     ; zamaskovn nepotebnch bit
        movwf   new             ; pepis stavu tlatek do new
        clrf    pb        
        movlw   00h
        tris    pb              ; port B opt jako vstup
        btfss   stav1, push    
        goto    tl_b          
        clrf    old             ; nulovn old
        movf    new, w
        btfsc   stat, nula     
        bcf     stav1, push     ; bit shozen
        return             

tl_b    movf    old, w         
        andwf   new, w        
        btfss   stat, nula     
        goto    tl_c          
        movf    new, w       
        movwf   old
        return        

tl_c    bsf     stav1, push     ; nastaven bitu
        btfss   new, 1          ; stisknuto tlatko start/stop? 
        goto    tl_d          
        movlw   b'00000010'     
        xorwf   stav1, f
        bsf     stav1,hm        ;hm je 2 bit stav1
        bcf     stav1,zv
        return              
  
tl_d    btfss   new,2
        goto    tl_f
        movlw   b'00000010'
        xorwf   stav1,f
        bcf     stav1,hm
        movlw   b'00001000'
        xorwf   stav1,zv
        return 

tl_f    btfss   new,3
        goto    tl_g
        bsf     stav1,stop
        bcf     stav1,hm
        movlw   sec
        movwf   fsr
        movlw   99h            
        movwf   konec
        call    akt          
        movf    sec,w
        movwf   secu
        return

tl_g    bsf     stav1,stop
        bcf     stav1,hm
        movlw   sec
        movwf   fsr
        movlw   00h
        movwf   zac
        call    dec 
        movf    sec,w
        movwf   secu
        return
 
;dekrementace
dec      movlw   b'11111111'
         addwf   ind,f
         btfsc   stat,dcarry
         goto    dec_a
         movlw   .6
         subwf   ind,f
dec_a    movf    zac,w
         xorwf   ind,w 
         btfsc   stat,nula       ;nula = Z bit
         incf    ind,1 
         return

;inkrementace
akt     movlw   .7
        addwf   ind, f         
        btfsc   stat, dcarry
        goto    akt_a
        movlw   .6
        subwf   ind, f
akt_a   movf    konec, w
        xorwf   ind, w
        btfsc   stat, nula   
        decf    ind,1         
        return

; ekn 5ms 
cek_5   comf    rtcc, w
        btfss   stat, nula      
        goto    cek_5          
                                
cek_5_a btfsc   rtcc, 0         
        goto    cek_5_a         
        return

; Inicializace

init    movlw   0ffh            ; nastaven portu A
        movwf   pa          
        clrf    pb         
        movlw   00h
        tris    pa           
        tris    pb          
        movlw   b'00000011'
        option                  ; peddli 1:16
        clrf    stav1
        clrf    cit_m
        movlw   15h 
        movwf   sec         
        movlw   15h
        movwf   secu
        clrf    new
        clrf    old
        bsf     stav1,stop
        goto    real           

real    movlw   .200
        movwf   citac           ; hlavn ta na 1s
real_a  decfsz  citac, f      
        goto    real_b          ;
        movlw   .200
        movwf   citac           ; znovunastaven tae
        btfsc   stav1,stop      
        goto    real_b
        btfsc   stav1,zv
        goto    real_b 
        movlw   secu
        movwf   fsr
        movlw   00h
        movwf   k
decr    movlw   b'11111111'
        addwf   ind,f
        btfsc   stat,dcarry
        goto    decr_a
        movlw   .6
        subwf   ind,f
decr_a  movf    k,w
        xorwf   ind,w 
        btfsc   stat,nula       ;nula = Z bit
        call    a

real_b  call    tlac
        call    zobraz          
        call    cek_5           
        goto    real_a
         
        end
